<template>
  <v-container class="fill-height">
    <v-row>
      <v-col>
        <v-icon color="primary" icon="fas fa-person-digging" style="font-size: 20vw" />
        <div class="text-h3 mt-6 mb-8">
          {{ $t("maintenance.header") }}
        </div>
        <div class="mb-4" style="font-size: 1.25rem">
          {{ $t("maintenance.message") }}
        </div>
      </v-col>
    </v-row>
  </v-container>
  <v-btn color="primary" :href="maintenanceInfoUrl" size="x-large" variant="elevated">
    {{ $t("maintenance.infoButton") }}
  </v-btn>
</template>

<script lang="ts">
import { MAINTENANCE_MODE, store } from "@/ts/common";
import { defineComponent } from "vue";
import { Locale } from "vue-i18n";
import { MaintenanceInfoUrls } from "@/ts/types";

export default defineComponent({
  beforeRouteEnter(_1, _2, next) {
    // Redirect to home if one of these is true
    // * Maintenance mode is disabled
    // * Login is allowed and user is logged out
    // * Ignoring maintenance mode is allowed and user is permitted to ignore maintenance mode
    if (
      !MAINTENANCE_MODE.enabled ||
      (store.user == null && MAINTENANCE_MODE.allowLogin) ||
      (MAINTENANCE_MODE.allowIgnoreMaintenance && store.user?.allowedToIgnoreMaintenance)
    ) {
      next({ name: "home" });
    } else {
      next();
    }
  },
  setup() {
    return {
      MAINTENANCE_MODE,
    };
  },
  data() {
    return {
      maintenanceInfoUrl: "",
    };
  },
  watch: {
    "$i18n.locale": function (newLocale: Locale) {
      this.setMaintenanceInfoUrl(newLocale);
    },
  },
  beforeMount() {
    this.setMaintenanceInfoUrl(this.$i18n.locale);
  },
  methods: {
    setMaintenanceInfoUrl: function (newLocale: Locale) {
      if (newLocale in MAINTENANCE_MODE.infoUrl) {
        this.maintenanceInfoUrl = MAINTENANCE_MODE.infoUrl[newLocale as keyof MaintenanceInfoUrls];
      } else {
        this.maintenanceInfoUrl = MAINTENANCE_MODE.infoUrl.en;
      }
    },
  },
});
</script>
